#include <pspkernel.h>
#include <pspdebug.h>
#include <pspaudiolib.h>
#include <pspaudio.h>
#include <pspdisplay.h>
#include <pspctrl.h>

PSP_MODULE_INFO("soundtest2", 0, 1, 1);
PSP_MAIN_THREAD_ATTR(THREAD_ATTR_USER | THREAD_ATTR_VFPU);

// f[^Q
extern short bomb_start[];
extern long bomb_size;
extern short shot_start[];
extern long shot_size;

int main(void) {
	pspDebugScreenInit(); pspAudioInit(); // I[fBI
	int channel_1=0,channel_2=0;
	int pspsample=0,keyflag=0;
	// L[͊֘A
	SceCtrlData pad; sceCtrlSetSamplingCycle(0); sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG);
	while(1) {
		sceCtrlReadBufferPositive(&pad, 1);
		if(keyflag==0){
			if(pad.Buttons & 0x2000){
				sceAudioChRelease(channel_1);
				pspsample=PSP_AUDIO_SAMPLE_ALIGN(bomb_size/4);
				channel_1=sceAudioChReserve(PSP_AUDIO_NEXT_CHANNEL,pspsample,PSP_AUDIO_FORMAT_STEREO);
				sceAudioOutput(channel_1,PSP_AUDIO_VOLUME_MAX,bomb_start);
				pspDebugScreenPrintf("O");
				keyflag=1; // Ah~
			}
			if(pad.Buttons & 0x4000){
				sceAudioChRelease(channel_2);
				pspsample=PSP_AUDIO_SAMPLE_ALIGN(shot_size/4);
				channel_2=sceAudioChReserve(PSP_AUDIO_NEXT_CHANNEL,pspsample,PSP_AUDIO_FORMAT_STEREO);
				sceAudioOutput(channel_2,PSP_AUDIO_VOLUME_MAX,shot_start);
				pspDebugScreenPrintf("X");
				keyflag=1; // Ah~
			}
		}else if(pad.Buttons==0) keyflag=0;
		sceDisplayWaitVblankStart();
	}
	return 0;
}
